// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// WifiCC3000 is free software licensed under the Apache License 2.0
// by Valkyrie-MT

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class DiscoverWifiNetworksExample
    {
        public static void Main()
        {
            Debug.Print("CC3000 Wifi Network Discovery Example");

            var wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);

            var networks = wifi.NetworkScan();

            if (networks.Length > 0)
            {
                Debug.Print("\nFound " + networks.Length + " WiFi Netowrks: ");
                Debug.Print("SSID - Signal Strength - Security");
                Debug.Print("-----------------------------------");
                            
                foreach (var aNetwork in networks)
                    Debug.Print(aNetwork.Ssid + " - " + aNetwork.SignalStrength + (aNetwork.Security == WifiSecurityType.Open ? " - Open" : " - Secured"));
            }
            else
            {
                Debug.Print("Failed to find any WiFi Networks.  ");
            }

            wifi.Stop();
        }
    }
}


