// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// Hosted on Codeplex: http://cc3000.codeplex.com
// WifiCC3000 is free software licensed under the Apache License 2.0
//  Copyright 2012 ValkyrieTech, LLC

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class LLMNR_Test
    {
        static UdpSocket s = null;
        static bool waiting = true;
        static WifiAdapter wifi;

        public static void Main()
        {
            Debug.Print("CC3000 LLMNR Test");

            wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);
            wifi.Connected += wifi_Connected;

            // Manually specify a network
            //var ap = new AccessPoint() { Ssid = "linksys", Key = "password", Security = WifiSecurityType.WPA2 };
            //wifi.Connect(ap);

            while (waiting) System.Threading.Thread.Sleep(50);

            //wifi.Stop();  // turns off power to wifi adapter
        }

        static void wifi_Connected(WifiAdapter wifiAdapter)
        {
            Debug.Print("Woot!  We are now connected to Wifi!");
            Debug.Print("Network Name: " + wifiAdapter.SsidName);
            Debug.Print("IP address: " + wifiAdapter.IPAddress.ToAddress());
            //Debug.Print("MacAddress: " + wifiAdapter.MacAddress.ToHexString());
            Debug.Print("Gateway: " + wifiAdapter.Gateway.ToAddress());
            Debug.Print("DNS Server: " + wifiAdapter.DomainNameServer.ToAddress());

            s = wifiAdapter.OpenUdpSocket();

            // Listen for UDP messages sent to activated ports
            s.OnDataReceived += s_OnDataReceived;

            //ulSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

            //bind(ulSocket, &tSocketAddr, sizeof(sockaddr));

            ////Receive the multicast packet
            //recvfrom(ulSocket, &McastPacketRx[0], recvDataLen, 0, &from, &fromlen); 

            //s.Bind(new byte[] { 224, 0, 0, 252 }, 5355);  // LLMNR
            //s.Bind(new byte[] { 224, 0, 0, 251 }, 5353);  // MDNS

            s.Listen(5355, new byte[] { 224, 0, 0, 252 });  // LLMNR

            //s.Listen(new byte[] { 224, 0, 0, 251 }, 5353);  // LLMNR

            while (true)
            {
                Debug.Print("Receive From... ");
                System.Threading.Thread.Sleep(200);
                //s.RecieveFrom();

                //if (x != null)
                //{
                //    Debug.Print(x.ToHexString());
                //}
            }


            while (waiting) System.Threading.Thread.Sleep(100);

            s.OnDataReceived -= s_OnDataReceived;
        }

        static void s_OnDataReceived(UdpSocket sender, byte[] message, byte[] remoteIP, ushort remotePort)
        {
            
            Debug.Print("Data Received Event Fired!!!!!!!  from port " + remotePort);


            if (message[(message.Length/2) - 3] == 0x01)
            {
                byte[] llmnrResponse = Networking.DNS.ConstructDnsResponse("cc3000", new byte[2] { message[0], message[1] }, wifi.IPAddress);
                sender.Send(llmnrResponse, remoteIP, remotePort);
            }

        }
    }

 
}


