// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// WifiCC3000 is free software licensed under the Apache License 2.0
// by Valkyrie-MT

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class MoreExamples
    {
        static bool waiting = true;

        public static void Main()
        {
            Debug.Print("CC3000 More Examples");

            var wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);
            wifi.Connected += wifi_Connected;

            // Manually specify a network
            //var ap = new AccessPoint() { Ssid = "linksys", Key = "password", Security = WifiSecurityType.WPA2 };
            //wifi.Connect(ap);

            while (waiting) System.Threading.Thread.Sleep(50);

            wifi.Stop();  // turns off power to wifi adapter
        }

        static void wifi_Connected(WifiAdapter wifiAdapter)
        {
            Debug.Print("Woot!  We are now connected to Wifi!");
            Debug.Print("Network Name: " + wifiAdapter.SsidName);
            Debug.Print("IP address: " + wifiAdapter.IPAddress.ToAddress());
            //Debug.Print("MacAddress: " + wifiAdapter.MacAddress.ToHexString());
            Debug.Print("Gateway: " + wifiAdapter.Gateway.ToAddress());
            Debug.Print("DNS Server: " + wifiAdapter.DomainNameServer.ToAddress());

            var googleIp = wifiAdapter.LookupAddress("google.com");
            Debug.Print("google.com address is: " + googleIp.ToAddress());

            Debug.Print("Pinging google.com...");
            var pingResponse = wifiAdapter.Ping(googleIp);

            if (pingResponse != -1)
                Debug.Print("Ping response round-trip time: " + pingResponse + "ms");
            else
                Debug.Print("No Response to ping.");

            waiting = false;            
        }
     }
 }


