// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// WifiCC3000 is free software licensed under the Apache License 2.0
// by Valkyrie-MT

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class PatchProgrammer
    {

        public static void Main()
        {
            //Note: This Patch Programmer will use a LOT of flash program space, so some CPUs may not work with this method.  

            Debug.Print("CC3000 Wifi Patch Programmer");

            var wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);

            //wifi.ReadWriteTest();

            // Warning: DO NOT uncomment this line.  Passing the FAT Patch may brick your cc3000!
            //var result = wifi.PatchFirmware(FirmwareBytes.fw_patch, DriverBytes.wlan_drv_patch, FileAllocationTableBytes.fat_patch);
            
            var result = wifi.PatchFirmware(PatchBytes.MajorVersion, PatchBytes.MinorVersion, PatchBytes.Firmware, PatchBytes.Driver, null);

            if (result)
                Debug.Print("WOO HOO, Firmware successfully patched!");
            else
                Debug.Print("Patch failed!  Ugh, well... that sucks.  ");

        }
    }
}


