// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// WifiCC3000 is free software licensed under the Apache License 2.0
// by Valkyrie-MT

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class SmartConfigExample
    {
        static bool waiting = true;

        public static void Main()
        {
            Debug.Print("CC3000 Smart Config Example");

            var wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);
            wifi.Connected += wifi_Connected;

            wifi.ActivateSmartConfig(30);

            while (waiting) System.Threading.Thread.Sleep(50);

            wifi.Stop();
        }

        static void wifi_Connected(WifiAdapter wifiAdapter)
        {
            Debug.Print("Woot!  We are now connected to Wifi!");
            Debug.Print("Network Name: " + wifiAdapter.SsidName);
            Debug.Print("IP address: " + wifiAdapter.IPAddress.ToAddress());
            //Debug.Print("MacAddress: " + wifiAdapter.MacAddress.ToHexString());
            Debug.Print("Gateway: " + wifiAdapter.Gateway.ToAddress());
            Debug.Print("DNS Server: " + wifiAdapter.DomainNameServer.ToAddress());

            wifiAdapter.SendDeviceAdvertisement();

            waiting = false;
        }
    }
}


