// This file is part of WifiCC3000 - the Managed Wifi Driver for the TI CC3000
// Hosted on Codeplex: http://cc3000.codeplex.com
// WifiCC3000 is free software licensed under the Apache License 2.0
//  Copyright 2012 ValkyrieTech, LLC

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Networking;
using System.Text;

namespace WifiExampleApp
{
    public class WebServerExample
    {
        static TcpSocket s = null;

        public static void Main()
        {
            Debug.Print("CC3000 Web Server Example Application");

            var wifi = new WifiAdapter("CC3000", InterfaceProfile.VTech_Device2);
            wifi.Connected += wifi_Connected;

            // Manually specify a network
            //var ap = new AccessPoint() { Ssid = "linksys", Key = "password", Security = WifiSecurityType.WPA2 };
            //wifi.Connect(ap);

            while (true) System.Threading.Thread.Sleep(5);
        }

        static void wifi_Connected(WifiAdapter wifiAdapter)
        {
            Debug.Print("Woot!  We are now connected to Wifi!");
            Debug.Print("Network Name: " + wifiAdapter.SsidName);
            Debug.Print("IP address: " + wifiAdapter.IPAddress.ToAddress());
            //Debug.Print("MacAddress: " + wifiAdapter.MacAddress.ToHexString());
            Debug.Print("Gateway: " + wifiAdapter.Gateway.ToAddress());
            Debug.Print("DNS Server: " + wifiAdapter.DomainNameServer.ToAddress());

            s = wifiAdapter.OpenTcpSocket();
            s.OnDataReceived += s_OnDataReceived;

            s.Listen(80);
        }

        static void s_OnDataReceived(TcpSocket sender, byte[] message, byte[] remoteIP, ushort remotePort)
        {
            Debug.Print("New Message Received: " + new string(Encoding.UTF8.GetChars(message)));

            var body = "<html><head><meta http-equiv=\"refresh\" content=\"10\"></head><body><font face=\"verdana\"><h1>The CC3000 Managed Driver</h1><p>for .NET MicroFramework</p><p>This is just the beginning :)</p><p><a href=\"http://cc3000.codeplex.com\">Visit us at Codeplex!</a></p></font></body></html>";

            var response = new HttpResponse(body);
            //response.Connection = "Close";

            sender.Send(response.HeaderSection);
            sender.Send(Encoding.UTF8.GetBytes(body));

            //sender.Close();
        }
    }
}
